// sigwinver.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "sigwinver.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void verify(void);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SIGWINVER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SIGWINVER);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SIGWINVER);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_SIGWINVER;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case ID_FILE_VERIFY:
			verify();
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

void MyHandleError(TCHAR *msg)
{
	MessageBox(NULL,msg,"Error",MB_OK|MB_ICONERROR);
}

void Info(TCHAR *msg)
{
	MessageBox(NULL,msg,"Info",MB_OK|MB_ICONINFORMATION);
}

void verify(void)
{
FILE *f=fopen("fail_text.txt.sgn","rb");
if(!f)return;
BYTE sgn[10000];
size_t sgn_length=fread(sgn,1,10000,f);
if(!sgn_length)return;
fclose(f);

#define MAX_NAME 256
HCRYPTMSG hMsg;
HCERTSTORE hStoreHandle;   
DWORD cbData = sizeof(DWORD);
DWORD cbDecoded;
BYTE *pbDecoded;
DWORD cbSignerCertInfo;
PCERT_INFO pSignerCertInfo;
PCCERT_CONTEXT pSignerCertContext;
char pszNameString[MAX_NAME];


if(hMsg = CryptMsgOpenToDecode(
   PKCS_7_ASN_ENCODING | X509_ASN_ENCODING,      // Encoding type.
   0,                     // Flags.
   0,                     // Use the default message type.
                          // The message type is 
                          // listed in the message header.
   NULL,                  // Cryptographic provider. Use NULL
                          // for the default provider.
   NULL,                  // Recipient information.
   NULL))                 // Stream information.
{
     Info("The message to decode is open. \n");
}
else
{
    MyHandleError("OpenToDecode failed");
}
//--------------------------------------------------------------------
//  Update the message with an encoded BLOB.
//  Both pbEncodedBlob, the encoded data, 
//  and cbEnclodeBlob, the length of the encoded data,
//  must be available. 

if(CryptMsgUpdate(
    hMsg,                 // Handle to the message
    sgn,        // Pointer to the encoded BLOB
    (DWORD)sgn_length,        // Size of the encoded BLOB
    TRUE))                // Last call
{
      Info("The encoded BLOB has been added to the message. \n");
}
else
{
    MyHandleError("Decode MsgUpdate failed");
}

//--------------------------------------------------------------------
//  Get the number of bytes needed for a buffer
//  to hold the decoded message.

if(CryptMsgGetParam(
    hMsg,                  // Handle to the message
    CMSG_CONTENT_PARAM,    // Parameter type
    0,                     // Index
    NULL,                 
    &cbDecoded))           // Size of the returned 
                           // information.
{
    Info("The message parameter has been acquired. \n");
}
else
{
    MyHandleError("Decode CMSG_CONTENT_PARAM failed");
}
//--------------------------------------------------------------------
// Allocate memory.

if(!(pbDecoded = (BYTE *) malloc(cbDecoded+10)))
{
    MyHandleError("Decode memory allocation failed");
}

//--------------------------------------------------------------------
// Copy the content to the buffer.

if(CryptMsgGetParam(
   hMsg,                 // Handle to the message
   CMSG_CONTENT_PARAM,   // Parameter type
   0,                    // Index
   pbDecoded,            // Address for returned 
                         // information.
   &cbDecoded))          // Size of the returned        
                         // information.
{
	pbDecoded[cbDecoded]=0;
    Info((TCHAR*)pbDecoded);
}
else
{
   MyHandleError("Decode CMSG_CONTENT_PARAM #2 failed");
}

//--------------------------------------------------------------------
// Verify the signature.
// First, get the signer CERT_INFO from the message.

//--------------------------------------------------------------------
// Get the size of memory required for the certificate.

if(CryptMsgGetParam(
   hMsg,                         // Handle to the message
   CMSG_SIGNER_CERT_INFO_PARAM,  // Parameter type
   0,                            // Index
   NULL,   
   &cbSignerCertInfo))           // Size of the returned 
                                 // information.
{
   Info("Size of buffer is known.\n");
}
else
{
   MyHandleError("Verify SIGNER_CERT_INFO #1 failed");
}

//--------------------------------------------------------------------
// Allocate memory.

if(!(pSignerCertInfo = (PCERT_INFO) malloc(cbSignerCertInfo)))
{
    MyHandleError("Verify memory allocation failed");
}

//--------------------------------------------------------------------
// Get the message certificate information (CERT_INFO
// structure).

if(!(CryptMsgGetParam(
     hMsg,                         // Handle to the message
     CMSG_SIGNER_CERT_INFO_PARAM,  // Parameter type
     0,                            // Index
     pSignerCertInfo,              // Address for returned 
                                   //information.
     &cbSignerCertInfo)))          // Size of the returned 
                                   //information.
{
    MyHandleError("Verify SIGNER_CERT_INFO #2 failed");
}

//--------------------------------------------------------------------
// Open a certificate store in memory using CERT_STORE_PROV_MSG,
// which initializes it with the certificates from the message.

if(hStoreHandle = CertOpenStore(
   CERT_STORE_PROV_MSG,         // Store provider type 
   PKCS_7_ASN_ENCODING | X509_ASN_ENCODING,            // Encoding type
   NULL,                        // Cryptographic provider
                                // Use NULL for the default.                                  
   0,                           // Flags
   hMsg))                       // Handle to the message
{
    Info("The certificate store has been opened.");
}
else  
{
    MyHandleError("Verify open store failed");
}

//--------------------------------------------------------------------
// Find the signer's certificate in the store.

if(pSignerCertContext = CertGetSubjectCertificateFromStore(
    hStoreHandle,       // Handle to store
    PKCS_7_ASN_ENCODING | X509_ASN_ENCODING,   // Encoding type
    pSignerCertInfo))   // Pointer to retrieved CERT_CONTEXT
{
  if(CertGetNameString(
     pSignerCertContext,
     CERT_NAME_SIMPLE_DISPLAY_TYPE,
     0,
     NULL,
     pszNameString,
     MAX_NAME) > 1)
  {
     Info(pszNameString);
  }
  else
  {
     MyHandleError("Getting the signer's name failed.\n");
  }
}
else
{
    MyHandleError("Verify GetSubjectCert failed");
}

//--------------------------------------------------------------------
// Use the CERT_INFO from the signer certificate to verify
// the signature.

if(CryptMsgControl(
     hMsg,                       // Handle to the message
     0,                          // Flags
     CMSG_CTRL_VERIFY_SIGNATURE, // Control type
     pSignerCertContext->pCertInfo))    // Pointer to the CERT_INFO
{
     Info("Verify signature succeeded. \n");
}
else
{
    Info("The signature was not verified. \n");
}
//--------------------------------------------------------------------
// Clean up.
if(pbDecoded)
   free(pbDecoded);
if(pSignerCertInfo)
   free(pSignerCertInfo);
if(pSignerCertContext)
   CertFreeCertificateContext(pSignerCertContext); 
if(hStoreHandle)
   CertCloseStore(hStoreHandle, CERT_CLOSE_STORE_FORCE_FLAG);
if(hMsg)
    CryptMsgClose(hMsg);
} 

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
